#ifndef BOOTSTRAP_CPUDEVICEMANAGER_H
#define BOOTSTRAP_CPUDEVICEMANAGER_H


#include "device.h"
#include "devicemanager.h"


struct CpuResult : Result {
    int n_threads;
};

class CpuDeviceManager : public DeviceManager {
public:
    CpuDeviceManager();
    virtual ~CpuDeviceManager() {};

    virtual void
    runAsync(std::vector<float> cumulative_input, int n_iterations, float p, Flags flags, int max_threads=1) override;

private:
    int n_threads;

    std::vector<std::unique_ptr<Result>> runThreadedBootstrap(std::vector<float> cumulative_input, int n_iterations, float p, Flags flags);
};

#endif //BOOTSTRAP_CPUDEVICEMANAGER_H
