#ifndef BOOTSTRAP_CUDADEVICEMANAGER_H
#define BOOTSTRAP_CUDADEVICEMANAGER_H

#include "devicemanager.h"

class CudaDeviceManager : public DeviceManager {
public:
    CudaDeviceManager(std::string iter_counts_file);

    virtual void
    runAsync(std::vector<float> cumulative_input, int n_iterations, float p, Flags flags, int max_threads=1) override;

    static int getNumAvailableDevices();

    std::vector<int> iter_counts;

private:
    std::string iter_counts_file;

    std::vector<std::unique_ptr<Result>> run(std::vector<float> cumulative_input, std::vector<int> n_iterations, float p, Flags flags);

    std::vector<int> getLoadBalance(int n_iterations);
};

#endif //BOOTSTRAP_CUDADEVICEMANAGER_H
