#ifndef BOOTSTRAP_DEVICEMANAGER_H
#define BOOTSTRAP_DEVICEMANAGER_H

#include "device.h"

struct Result {
    std::string device_type;
    std::string device_name;

    std::vector<float> averages;

    struct {
        int n_iterations;
        float p;
        Timer total_time;
    } stats;
};

class DeviceManager {
public:
    DeviceManager() {}

    virtual ~DeviceManager() {}

    virtual void
    runAsync(std::vector<float> cumulative_input, int n_iterations, float p, Flags flags, int max_threads=1) = 0;

    virtual std::vector<std::unique_ptr<Result>> getResults();

    std::vector<std::shared_ptr<Device>> getDevices();

    double getEstimate(int n_iterations);
    double getDEstimate(int n_iterations);

protected:
    std::future<std::vector<std::unique_ptr<Result>>> future;
    std::vector<std::shared_ptr<Device>> devices;
};

#endif //BOOTSTRAP_DEVICEMANAGER_H
