#ifndef BOOTSTRAP_KERNELS_H
#define BOOTSTRAP_KERNELS_H

#include <curand_kernel.h>

__global__ void _init_prng(int *seeds, curandState_t *states, int n_bootstrap_iterations);

__global__ void _bootstrap_block(float *cumulativeInput, int cumulativeInputSize,
                                 float *out, int n_bootstrap_iterations,
                                 curandState_t *states, float p);

__global__ void _bootstrap_block_long(float *cumulativeInput, int cumulativeInputSize,
                                     float *out, int n_bootstrap_iterations,
                                     curandState_t *states, float p);

__global__ void _bootstrap_block_iteration_counts(
        int cumulativeInputSize,
        int *out,
        int n_bootstrap_iterations,
        curandState_t *states,
        float p
);

__global__ void _bootstrap_force_variance(float *cumulativeInput, int cumulativeInputSize,
                                          float *out, int n_bootstrap_iterations,
                                          curandState_t *states, float p, float mu, float sigma);

__global__ void _bootstrap_force_variance_iteration_counts(
        int cumulativeInputSize,
        int *out,
        int n_bootstrap_iterations,
        curandState_t *states,
        float p,
        float mu,
        float sigma
);

__global__ void _generate_seeds(int global_seed, int *out, int n_iterations);


#endif //BOOTSTRAP_KERNELS_H
