#ifndef BOOTSTRAP_SERIALIZER_H
#define BOOTSTRAP_SERIALIZER_H

#include <string.h>
#include <cstdint>
#include <fstream>
#include <vector>

class Serializer {
public:
    Serializer() : stream(0)
    {

    }

    void save(std::string filename) {
        std::ofstream output(filename, std::ios::out | std::ios::binary | std::ios::trunc);

        for (auto byte : stream) {
            output << byte;
        }

        output.close();
    }

    template <typename T>
    friend Serializer &operator<<(Serializer &serializer, T primitive);

private:
    std::vector<uint8_t> stream;
};

template <typename T>
Serializer &operator<<(Serializer &serializer, T primitive) {
    int size = sizeof (T);

    uint8_t *bytes = reinterpret_cast<uint8_t *>(&primitive);

    for (int i = 0; i < size; i++) {
        serializer.stream.push_back(bytes[i]);
    }

    return serializer;
}

#endif //BOOTSTRAP_SERIALIZER_H
