#include <devicemanager.h>


std::vector<std::unique_ptr<Result>>
DeviceManager::getResults() {
    // This is true when future was default constructed
    if (!future.valid()) {
        throw Exception("runAsync must be called before calling getResults!");
    }
    return future.get();
}

std::vector<std::shared_ptr<Device>> DeviceManager::getDevices() {
    return devices;
}

double DeviceManager::getEstimate(int n_iterations) {
    return devices[0]->getCost(n_iterations);
}

double DeviceManager::getDEstimate(int n_iterations) {
    return devices[0]->getDCost(n_iterations);
}
